////////////////////////////////////////////////////////////////////////
//	vWFNg	:	R[hϊCu
//
//	J		:	Visual Studio 2010
//
//	Ώۃc[		:	Visual Studio 2010
//
//	@@		:	2010/ 1/13	by H.m
//
//	@@		:	ElementTech  Hidetoshi Matsui
////////////////////////////////////////////////////////////////////////
#pragma once

#include "EL_StdFunc.h"

////////////////////////////////////////////////////////////////////
//		}N`
////////////////////////////////////////////////////////////////////
#define	EL_CODECNV_USASCII	0x0400				// WEBCDIC
#define	EL_CODECNV_JPNKANA	0x0500				// JiEBCDIC
#define	EL_CODECNV_JPNENG	0x0600				// pEBCDIC

////////////////////////////////////////////////////////////////////
//		G[R[h̒`
////////////////////////////////////////////////////////////////////
enum	{
	EL_CCTBL_ERR_NONE,							// G[͂܂B
	EL_CCTBL_ERR_PARAMETER,						// p[^[ G[
	EL_CCTBL_ERR_TABLE_OPEN,					// R[hϊe[u܂B
	EL_CCTBL_ERR_BINARY_OPEN,					// oCi[ϊt@C쐬ł܂B
	EL_CCTBL_ERR_TABLE_READ,					// R[hϊe[u̓ǂݍ݂Ɏs܂B
	EL_CCTBL_ERR_BINARY_WRITE,					// oCi[f[^݂̏Ɏs܂B
	EL_CCTBL_ERR_TABLE_FORMAT,					// R[hϊe[ũtH[}bgɈُ킪܂B
	EL_CCTBL_ERR_TABLE_ZERO,					// R[hϊe[uɗLȃR[h܂B
	EL_CCTBL_ERR_TABLE_MAPPING,					// oCi[t@C}bsOł܂łB
};

////////////////////////////////////////////////////////////////////
//		ϊ̒`
////////////////////////////////////////////////////////////////////
enum	{
	EL_CCTBL_LEFT_TO_RIGHT,						// e[u̍E֕ϊ
	EL_CCTBL_RIGHT_TO_LEFT						// e[ủE獶֕ϊ
};

////////////////////////////////////////////////////////////////////
//		URLGR[h^Cv`
////////////////////////////////////////////////////////////////////
enum	{
	EL_URL_ENCODE_JIS,										// JISR[h
	EL_URL_ENCODE_SJIS,										// SHIFT-JISR[h
	EL_URL_ENCODE_EUC,										// EUC-JPR[h
	EL_URL_ENCODE_UTF8										// UTF-8R[h
};

////////////////////////////////////////////////////////////////////
//		R[hϊe[u\(oCi[)
////////////////////////////////////////////////////////////////////
struct	EL_CCTLB_CODE	{
	LONG			m_lCodeLeft;				// ̃R[h
	LONG			m_lCodeRight;				// ẼR[h
};

struct	EL_CCTLB_TBL	{
	LONG			m_nCount;					// e[ũR[h
	EL_CCTLB_CODE	m_pCodeTable[1];			// R[hϊe[u
};
typedef	EL_CCTLB_TBL	*EL_PCCTBL_TBL;

////////////////////////////////////////////////////////////////////
//		R[hϊe[uEnh
////////////////////////////////////////////////////////////////////
struct	EL_CCTBL	{
	WCHAR			m_wszTableBinary[MAX_PATH];	// oCi[e[ũtpX
	HANDLE			m_hFile;					// }bsOpt@CEnh
	HANDLE			m_hMapObject;				// }bvIuWFNg
	EL_PCCTBL_TBL	m_pCodeTable;				// R[hϊe[u
};
typedef	EL_CCTBL	*EL_HCCTBL;

////////////////////////////////////////////////////////////////////
//		SHIFT-JIS֘A̕ϊ
////////////////////////////////////////////////////////////////////
extern "C"	{
	int		__stdcall EL_SJisToUnicode(LPCSTR pszSJis, LPWSTR pwszUnicode, int nMaxSize);
	int		__stdcall EL_UnicodeToSJis(LPCWSTR pwszUnicode, LPSTR pszSJis, int nMaxSize);
	BOOL	__stdcall EL_IsMultiByteChar(LPCSTR pcszSJis);
}

////////////////////////////////////////////////////////////////////
//		JIS֘A̕ϊ
////////////////////////////////////////////////////////////////////
extern "C"	{
	int		__stdcall EL_JisToSJis(LPCSTR pcszJis, LPSTR pszSJis, int nMaxSize);
	int		__stdcall EL_JisToUnicode(LPCSTR pcszJis, LPWSTR pwszUnicode, int nMaxSize);
	int		__stdcall EL_SJisToJis(LPCSTR pcszSJis, LPSTR pszJis, int nMaxSize);
	int		__stdcall EL_UnicodeToJis(LPCWSTR pcwszUnicode, LPSTR pszJis, int nMaxSize);
}

////////////////////////////////////////////////////////////////////
//		EUC֘A̕ϊ
////////////////////////////////////////////////////////////////////
extern "C"	{
	int		__stdcall EL_EucToJis(LPCSTR pcszEuc, LPSTR pszJis, int nMaxSize);
	int		__stdcall EL_EucToSJis(LPCSTR pcszEuc, LPSTR pszSJis, int nMaxSize);
	int		__stdcall EL_EucToUnicode(LPCSTR pcszEuc, LPWSTR pwszUnicode, int nMaxSize);
	int		__stdcall EL_JisToEuc(LPCSTR pcszJis, LPSTR pszEuc, int nMaxSize);
	int		__stdcall EL_SJisToEuc(LPCSTR pcszSJis, LPSTR pszEuc, int nMaxSize);
	int		__stdcall EL_UnicodeToEuc(LPCWSTR pcwszUnicode, LPSTR pszEuc, int nMaxSize);
	BOOL	__stdcall EL_IsEucJpChar(LPCSTR pcszString);
}

////////////////////////////////////////////////////////////////////
//		UTF-7֘A̕ϊ
////////////////////////////////////////////////////////////////////
extern "C"	{
	int		__stdcall EL_Utf7ToUnicode(LPCSTR pcszUtf7, LPWSTR pwszUnicode, int nMaxSize);
	int		__stdcall EL_Utf7ToSJis(LPCSTR pcszUtf7, LPSTR pszSJis, int nMaxSize);
	int		__stdcall EL_UnicodeToUtf7(LPCWSTR pcwszUnicode, LPSTR pszUtf7, int nMaxSize);
	int		__stdcall EL_SJisToUtf7(LPCSTR pcszSJis, LPSTR pszUtf7, int nMaxSize);
}

////////////////////////////////////////////////////////////////////
//		UTF-8֘A̕ϊ
////////////////////////////////////////////////////////////////////
extern "C"	{
	int		__stdcall EL_Utf8ToUnicode(LPCSTR pcszUtf8, LPWSTR pwszUnicode, int nMaxSize);
	int		__stdcall EL_Utf8ToSJis(LPCSTR pcszUtf8, LPSTR pszSJis, int nMaxSize);
	int		__stdcall EL_UnicodeToUtf8(LPCWSTR pcwszUnicode, LPSTR pszUtf8, int nMaxSize);
	int		__stdcall EL_SJisToUtf8(LPCSTR pcszSJis, LPSTR pszUtf8, int nMaxSize);
	int		__stdcall EL_IsUtf8Char(LPCSTR pcszString);
}

////////////////////////////////////////////////////////////////////
//		EBCDIC֘A̕ϊ
////////////////////////////////////////////////////////////////////
extern "C"	{
	int		__stdcall EL_AsciiToEbcdic(LPCSTR pcszAscii, LPSTR pszEbcdic, int nMaxSize, int nType=EL_CODECNV_USASCII);
	int		__stdcall EL_EbcdicToAscii(LPCSTR pcszEbcdic, LPSTR pszAscii, int nMaxSize, int nType=EL_CODECNV_USASCII);
	BYTE	__stdcall EL_AsciiEbcdicCode(BYTE ucAscii, int nType);
	BYTE	__stdcall EL_EbcdicAsciiCode(BYTE ucEbcdic, int p_nType);
}

////////////////////////////////////////////////////////////////////
//		e[uϊ
////////////////////////////////////////////////////////////////////
extern "C"	{
	EL_HCCTBL	__stdcall EL_CodeTableInitW(LPCWSTR pcwszTable, int nDirection, int nEncode=EL_FILE_ENCODE_UNICODE, BOOL fSort=TRUE);
	EL_HCCTBL	__stdcall EL_CodeTableInitA(LPCSTR pcszTable, int nDirection, int nEncode=EL_FILE_ENCODE_SJIS, BOOL fSort=TRUE);
	LONG		__stdcall EL_CodeTableCode(EL_HCCTBL hTable, LONG lCode);
	int			__stdcall EL_CodeTableString(EL_HCCTBL hTable, LPCWSTR pcwszString, LPWSTR pwszString, int nLength);
	VOID		__stdcall EL_CodeTableTerm(EL_HCCTBL hTable);
	int			__stdcall EL_CodeTableError(VOID);
	LONG		__stdcall EL_CodeTableErrorLine(VOID);
}
#ifdef _UNICODE
	#define	EL_CodeTableInit			EL_CodeTableInitW
#else
	#define	EL_CodeTableInit			EL_CodeTableInitA
#endif

////////////////////////////////////////////////////////////////////
//		URL֘ACu
////////////////////////////////////////////////////////////////////
extern "C"	{
	// Unicode
	BOOL	__stdcall EL_URL_IsProtocolW(LPCWSTR pcwszString);
	BOOL	__stdcall EL_URL_IsJisEncodeW(LPCWSTR pcwszUrl);
	BOOL	__stdcall EL_URL_IsSJisEncodeW(LPCWSTR pcwszUrl);
	BOOL	__stdcall EL_URL_IsEucEncodeW(LPCWSTR pcwszUrl);
	BOOL	__stdcall EL_URL_IsUtf8EncodeW(LPCWSTR pcwszUrl);
	int		__stdcall EL_URL_EncodeTypeW(LPCWSTR pcwszUrl);
	int		__stdcall EL_URL_DecodeJisW(LPCWSTR pcwszUrl, LPWSTR pwszDecode, int nLength);
	int		__stdcall EL_URL_DecodeSJisW(LPCWSTR pcwszUrl, LPWSTR pwszDecode, int nLength);
	int		__stdcall EL_URL_DecodeEucW(LPCWSTR pcwszUrl, LPWSTR pwszDecode, int nLength);
	int		__stdcall EL_URL_DecodeUtf8W(LPCWSTR pcwszUrl, LPWSTR pwszDecode, int nLength);
	int		__stdcall EL_URL_DecodeW(LPCWSTR pcwszUrl, LPWSTR pwszDecode, int nLength, int* pnEncType);
	int		__stdcall EL_URL_EncodeW(LPCWSTR pcwszString, LPWSTR pwszEncode, int nLength, int nEncType=EL_URL_ENCODE_UTF8);

	// ANSI
	BOOL	__stdcall EL_URL_IsProtocolA(LPCSTR pcszString);
	BOOL	__stdcall EL_URL_IsJisEncodeA(LPCSTR pcszUrl);
	BOOL	__stdcall EL_URL_IsSJisEncodeA(LPCSTR pcszUrl);
	BOOL	__stdcall EL_URL_IsEucEncodeA(LPCSTR pcszUrl);
	BOOL	__stdcall EL_URL_IsUtf8EncodeA(LPCSTR pcszUrl);
	int		__stdcall EL_URL_EncodeTypeA(LPCSTR pcszUrl);
	int		__stdcall EL_URL_DecodeJisA(LPCSTR pcszUrl, LPSTR pszDecode, int nLength);
	int		__stdcall EL_URL_DecodeSJisA(LPCSTR pcszUrl, LPSTR pszDecode, int nLength);
	int		__stdcall EL_URL_DecodeEucA(LPCSTR pcszUrl, LPSTR pszDecode, int nLength);
	int		__stdcall EL_URL_DecodeUtf8A(LPCSTR pcszUrl, LPSTR pszDecode, int nLength);
	int		__stdcall EL_URL_DecodeA(LPCSTR pcszUrl, LPSTR pszDecode, int nLength, int* pnEncType);
	int		__stdcall EL_URL_EncodeA(LPCSTR pcszString, LPSTR pszEncode, int nLength, int nEncType);
}
#ifdef _UNICODE
	#define	EL_URL_IsProtocol			EL_URL_IsProtocolW
	#define	EL_URL_IsJisEncode			EL_URL_IsJisEncodeW
	#define	EL_URL_IsSJisEncode			EL_URL_IsSJisEncodeW
	#define	EL_URL_IsEucEncode			EL_URL_IsEucEncodeW
	#define	EL_URL_IsUtf8Encode			EL_URL_IsUtf8EncodeW
	#define	EL_URL_EncodeType			EL_URL_EncodeTypeW
	#define	EL_URL_DecodeJis			EL_URL_DecodeJisW
	#define	EL_URL_DecodeSJis			EL_URL_DecodeSJisW
	#define	EL_URL_DecodeEuc			EL_URL_DecodeEucW
	#define	EL_URL_DecodeUtf8			EL_URL_DecodeUtf8W
	#define	EL_URL_Decode				EL_URL_DecodeW
	#define	EL_URL_Encode				EL_URL_EncodeW
#else
	#define	EL_URL_IsProtocol			EL_URL_IsProtocolA
	#define	EL_URL_IsJisEncode			EL_URL_IsJisEncodeA
	#define	EL_URL_IsSJisEncode			EL_URL_IsSJisEncodeA
	#define	EL_URL_IsEucEncode			EL_URL_IsEucEncodeA
	#define	EL_URL_IsUtf8Encode			EL_URL_IsUtf8EncodeA
	#define	EL_URL_EncodeType			EL_URL_EncodeTypeA
	#define	EL_URL_DecodeJis			EL_URL_DecodeJisA
	#define	EL_URL_DecodeSJis			EL_URL_DecodeSJisA
	#define	EL_URL_DecodeEuc			EL_URL_DecodeEucA
	#define	EL_URL_DecodeUtf8			EL_URL_DecodeUtf8A
	#define	EL_URL_Decode				EL_URL_DecodeA
	#define	EL_URL_Encode				EL_URL_EncodeA
#endif

////////////////////////////////////////////////////////////////////
//		BASE64֘ACu
////////////////////////////////////////////////////////////////////
extern "C"	{
	int		__stdcall EL_Base64_Encode(const LPBYTE pcbSource, int nSize, LPSTR pszBase64, int nLength);
	int		__stdcall EL_Base64_Decode(LPCSTR pcszBase64, LPBYTE pbDestination, int nSize);

	int		__stdcall EL_Base64_EncodeJISW(LPCWSTR pwszString, LPSTR pszBase64, int nLength);
	int		__stdcall EL_Base64_EncodeJISA(LPCSTR  pszString,  LPSTR pszBase64, int nLength);
	int		__stdcall EL_Base64_EncodeSJISW(LPCWSTR pcwszString, LPSTR pszBase64, int nLength);
	int		__stdcall EL_Base64_EncodeSJISA(LPCSTR  pcszString,  LPSTR pszBase64, int nLength);
	int		__stdcall EL_Base64_EncodeEUCW(LPCWSTR pcwszString, LPSTR pszBase64, int nLength);
	int		__stdcall EL_Base64_EncodeEUCA(LPCSTR  pcszString,  LPSTR pszBase64, int nLength);
	int		__stdcall EL_Base64_EncodeUTF8W(LPCWSTR pcwszString, LPSTR pszBase64, int nLength);
	int		__stdcall EL_Base64_EncodeUTF8A(LPCSTR  pcszString,  LPSTR pszBase64, int nLength);
	int		__stdcall EL_Base64_DecodeJISW(LPCSTR pcszBase64, LPWSTR pwszString, int nLength);
	int		__stdcall EL_Base64_DecodeJISA(LPCSTR pcszBase64, LPSTR  pszString,  int nLength);
	int		__stdcall EL_Base64_DecodeSJISW(LPCSTR pcszBase64, LPWSTR pwszString, int nLength);
	int		__stdcall EL_Base64_DecodeSJISA(LPCSTR pcszBase64, LPSTR  pszString,  int nLength);
	int		__stdcall EL_Base64_DecodeEUCW(LPCSTR pcszBase64, LPWSTR pwszString, int nLength);
	int		__stdcall EL_Base64_DecodeEUCA(LPCSTR pcszBase64, LPSTR  pszString,  int nLength);
	int		__stdcall EL_Base64_DecodeUTF8W(LPCSTR pcszBase64, LPWSTR pwszString, int nLength);
	int		__stdcall EL_Base64_DecodeUTF8A(LPCSTR pcszBase64, LPSTR  pszString,  int nLength);
}
#ifdef _UNICODE
	#define	EL_Base64_EncodeJIS			EL_Base64_EncodeJISW
	#define	EL_Base64_EncodeSJIS		EL_Base64_EncodeSJISW
	#define	EL_Base64_EncodeEUC			EL_Base64_EncodeEUCW
	#define	EL_Base64_EncodeUTF8		EL_Base64_EncodeUTF8W
	#define	EL_Base64_DecodeJIS			EL_Base64_DecodeJISW
	#define	EL_Base64_DecodeSJIS		EL_Base64_DecodeSJISW
	#define	EL_Base64_DecodeEUC			EL_Base64_DecodeEUCW
	#define	EL_Base64_DecodeUTF8		EL_Base64_DecodeUTF8W
#else
	#define	EL_Base64_EncodeJIS			EL_Base64_EncodeJISA
	#define	EL_Base64_EncodeSJIS		EL_Base64_EncodeSJISA
	#define	EL_Base64_EncodeEUC			EL_Base64_EncodeEUCA
	#define	EL_Base64_EncodeUTF8		EL_Base64_EncodeUTF8A
	#define	EL_Base64_DecodeJIS			EL_Base64_DecodeJISA
	#define	EL_Base64_DecodeSJIS		EL_Base64_DecodeSJISA
	#define	EL_Base64_DecodeEUC			EL_Base64_DecodeEUCA
	#define	EL_Base64_DecodeUTF8		EL_Base64_DecodeUTF8A
#endif

////////////////////////////////////////////////////////////////////
//		Quoted-Printable֘ACu
////////////////////////////////////////////////////////////////////
extern "C"	{
	int		__stdcall EL_QuotedPrintable_Encode(const LPBYTE pcbSource, int nSize, LPSTR pszQPrint, int nLength);
	int		__stdcall EL_QuotedPrintable_Decode(LPCSTR pcszQPrint, LPBYTE pbDestination, int nSize);

	int		__stdcall EL_QuotedPrintable_EncodeJISW(LPCWSTR  pcwszString, LPSTR pszQPrint, int nLength);
	int		__stdcall EL_QuotedPrintable_EncodeJISA(LPCSTR   pcszString,  LPSTR pszQPrint, int nLength);
	int		__stdcall EL_QuotedPrintable_EncodeSJISW(LPCWSTR pcwszString, LPSTR pszQPrint, int nLength);
	int		__stdcall EL_QuotedPrintable_EncodeSJISA(LPCSTR  pcszString,  LPSTR pszQPrint, int nLength);
	int		__stdcall EL_QuotedPrintable_EncodeEUCW(LPCWSTR  pcwszString, LPSTR pszQPrint, int nLength);
	int		__stdcall EL_QuotedPrintable_EncodeEUCA(LPCSTR   pcszString,  LPSTR pszQPrint, int nLength);
	int		__stdcall EL_QuotedPrintable_EncodeUTF8W(LPCWSTR pcwszString, LPSTR pszQPrint, int nLength);
	int		__stdcall EL_QuotedPrintable_EncodeUTF8A(LPCSTR  pcszString,  LPSTR pszQPrint, int nLength);
	int		__stdcall EL_QuotedPrintable_DecodeJISW(LPCSTR  pcszQPrint, LPWSTR pwszString, int nLength);
	int		__stdcall EL_QuotedPrintable_DecodeJISA(LPCSTR  pcszQPrint, LPSTR  pszString,  int nLength);
	int		__stdcall EL_QuotedPrintable_DecodeSJISW(LPCSTR pcszQPrint, LPWSTR pwszString, int nLength);
	int		__stdcall EL_QuotedPrintable_DecodeSJISA(LPCSTR pcszQPrint, LPSTR  pszString,  int nLength);
	int		__stdcall EL_QuotedPrintable_DecodeEUCW(LPCSTR  pcszQPrint, LPWSTR pwszString, int nLength);
	int		__stdcall EL_QuotedPrintable_DecodeEUCA(LPCSTR  pcszQPrint, LPSTR  pszString,  int nLength);
	int		__stdcall EL_QuotedPrintable_DecodeUTF8W(LPCSTR pcszQPrint, LPWSTR pwszString, int nLength);
	int		__stdcall EL_QuotedPrintable_DecodeUTF8A(LPCSTR pcszQPrint, LPSTR  pszString,  int nLength);
}
#ifdef _UNICODE
	#define	EL_QuotedPrintable_EncodeJIS	EL_QuotedPrintable_EncodeJISW
	#define	EL_QuotedPrintable_EncodeSJIS	EL_QuotedPrintable_EncodeSJISW
	#define	EL_QuotedPrintable_EncodeEUC	EL_QuotedPrintable_EncodeEUCW
	#define	EL_QuotedPrintable_EncodeUTF8	EL_QuotedPrintable_EncodeUTF8W
	#define	EL_QuotedPrintable_DecodeJIS	EL_QuotedPrintable_DecodeJISW
	#define	EL_QuotedPrintable_DecodeSJIS	EL_QuotedPrintable_DecodeSJISW
	#define	EL_QuotedPrintable_DecodeEUC	EL_QuotedPrintable_DecodeEUCW
	#define	EL_QuotedPrintable_DecodeUTF8	EL_QuotedPrintable_DecodeUTF8W
#else
	#define	EL_QuotedPrintable_EncodeJIS	EL_QuotedPrintable_EncodeJISA
	#define	EL_QuotedPrintable_EncodeSJIS	EL_QuotedPrintable_EncodeSJISA
	#define	EL_QuotedPrintable_EncodeEUC	EL_QuotedPrintable_EncodeEUCA
	#define	EL_QuotedPrintable_EncodeUTF8	EL_QuotedPrintable_EncodeUTF8A
	#define	EL_QuotedPrintable_DecodeJIS	EL_QuotedPrintable_DecodeJISA
	#define	EL_QuotedPrintable_DecodeSJIS	EL_QuotedPrintable_DecodeSJISA
	#define	EL_QuotedPrintable_DecodeEUC	EL_QuotedPrintable_DecodeEUCA
	#define	EL_QuotedPrintable_DecodeUTF8	EL_QuotedPrintable_DecodeUTF8A
#endif

////////////////////////////////////////////////////////////////////
//		CZX
////////////////////////////////////////////////////////////////////
extern "C"	{
	BOOL	__stdcall EL_LicenseKeyOEM_CodeConvW(LPCWSTR pcwszLicenseKey);
	BOOL	__stdcall EL_LicenseKeyOEM_CodeConvA(LPCSTR  pcszLicenseKey);
}
#ifdef _UNICODE
	#define	EL_LicenseKeyOEM_CodeConv		EL_LicenseKeyOEM_CodeConvW
#else
	#define	EL_LicenseKeyOEM_CodeConv		EL_LicenseKeyOEM_CodeConvA
#endif
